'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContentManager = undefined;

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _reactiveCache = require('./reactiveCache');

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('fil:contentManager');

var ContentManager = exports.ContentManager = function () {
  function ContentManager(_ref) {
    var _this = this;

    var project = _ref.project,
        checkForChanges = _ref.checkForChanges;
    (0, _classCallCheck3.default)(this, ContentManager);

    this._project = project;
    this._checkForChanges = checkForChanges;
    this._cache = new _reactiveCache.ReactiveCache();
    this._allContentsChangeSubscriber = null;
    this._allContentsChangeObservable = _Rx2.default.Observable.create(function (subscriber) {
      _this._allContentsChangeSubscriber = subscriber;
    });
  }

  (0, _createClass3.default)(ContentManager, [{
    key: 'contentTypes',
    value: function contentTypes() {
      return (0, _keys2.default)(this._project._project.contentTypes); // eslint-disable-line no-underscore-dangle
    }
  }, {
    key: 'metaOf',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref3) {
        var _this2 = this;

        var id = _ref3.id,
            type = _ref3.type;
        var handler, cacheEnabledCalculatorFn, useCache, valueFn, cacheKey;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                handler = this._getHandlerFor({ type: type });

                cacheEnabledCalculatorFn = handler.useChildrenCache || function () {
                  return Boolean(handler.childrenWatcher);
                };

                useCache = cacheEnabledCalculatorFn({ id: id, type: type });

                valueFn = function () {
                  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                    var childrenCalculatorFn, children;
                    return _regenerator2.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            childrenCalculatorFn = handler.children || ContentManager.defaultChildrenCalculator;
                            _context.next = 3;
                            return childrenCalculatorFn({
                              id: id,
                              project: _this2._project,
                              type: type
                            });

                          case 3:
                            children = _context.sent;
                            return _context.abrupt('return', {
                              children: children,
                              id: id,
                              type: type
                            });

                          case 5:
                          case 'end':
                            return _context.stop();
                        }
                      }
                    }, _callee, _this2);
                  }));

                  return function valueFn() {
                    return _ref4.apply(this, arguments);
                  };
                }();

                if (useCache) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt('return', valueFn());

              case 6:
                cacheKey = type + '/meta/' + id;
                return _context2.abrupt('return', this._cache.calculate({
                  id: cacheKey,
                  notifyFn: this._onChildrenChanged.bind(this, { id: id, type: type }),
                  valueFn: valueFn,
                  watchFn: this._getWatcherFunction({ candidateFn: handler.childrenWatcher, id: id, type: type })
                }));

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function metaOf(_x) {
        return _ref2.apply(this, arguments);
      }

      return metaOf;
    }()
  }, {
    key: 'valueOf',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref6) {
        var _this3 = this;

        var _data = _ref6._data,
            id = _ref6.id,
            type = _ref6.type;
        var handler, cacheEnabledCalculatorFn, useCache, valueFn, cacheKey;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                handler = this._getHandlerFor({ type: type });

                cacheEnabledCalculatorFn = handler.useContentCache || function () {
                  return Boolean(handler.contentWatcher);
                };

                useCache = cacheEnabledCalculatorFn({ id: id, type: type });

                valueFn = function () {
                  var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
                    return _regenerator2.default.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            return _context3.abrupt('return', handler.content({
                              _data: _data,
                              id: id,
                              project: _this3._project,
                              type: type
                            }));

                          case 1:
                          case 'end':
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this3);
                  }));

                  return function valueFn() {
                    return _ref7.apply(this, arguments);
                  };
                }();

                if (useCache) {
                  _context4.next = 6;
                  break;
                }

                return _context4.abrupt('return', valueFn());

              case 6:
                cacheKey = type + '/content/' + id;
                return _context4.abrupt('return', this._cache.calculate({
                  id: cacheKey,
                  notifyFn: this._onContentChanged.bind(this, { id: id, type: type }),
                  valueFn: valueFn,
                  watchFn: this._getWatcherFunction({ candidateFn: handler.contentWatcher, id: id, type: type })
                }));

              case 8:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function valueOf(_x2) {
        return _ref5.apply(this, arguments);
      }

      return valueOf;
    }()
  }, {
    key: 'watcher$',
    value: function watcher$() {
      return this._allContentsChangeObservable;
    }
  }, {
    key: 'persistCache',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt('return', this._cache.persistCache({
                  cachePath: this._project.cachePath,
                  key: 'contents'
                }));

              case 1:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function persistCache() {
        return _ref8.apply(this, arguments);
      }

      return persistCache;
    }()
  }, {
    key: 'loadCache',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var _this4 = this;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this._cache.loadCache({
                  cachePath: this._project.cachePath,
                  functionLoaderFn: function functionLoaderFn(_ref10) {
                    var cacheKey = _ref10.id;

                    var _cacheKey$split = cacheKey.split('/'),
                        _cacheKey$split2 = (0, _toArray3.default)(_cacheKey$split),
                        type = _cacheKey$split2[0],
                        cacheType = _cacheKey$split2[1],
                        idPieces = _cacheKey$split2.slice(2);

                    var id = idPieces.join('/');
                    var handler = _this4._getHandlerFor({ type: type });
                    if (cacheType === 'meta') {
                      return {
                        notifyFn: _this4._onChildrenChanged.bind(_this4, { id: id, type: type }),
                        watchFn: _this4._getWatcherFunction({ candidateFn: handler.childrenWatcher, id: id, type: type })
                      };
                    }

                    if (cacheType === 'content') {
                      return {
                        notifyFn: _this4._onContentChanged.bind(_this4, { id: id, type: type }),
                        watchFn: _this4._getWatcherFunction({ candidateFn: handler.contentWatcher, id: id, type: type })
                      };
                    }

                    throw new Error('I have no idea about how to load "' + id + '" from cache.');
                  },
                  key: 'contents'
                });

              case 2:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function loadCache() {
        return _ref9.apply(this, arguments);
      }

      return loadCache;
    }()

    /* Private operations */

  }, {
    key: '_getHandlerFor',
    value: function _getHandlerFor(_ref11) {
      var type = _ref11.type;

      var handlers = this._project._project.contentTypes; // eslint-disable-line no-underscore-dangle
      var handler = handlers[type];
      if (!handler) {
        throw new Error('Handler "' + type + '" can\'t be found.');
      }
      return handler;
    }
  }, {
    key: '_onContentChanged',
    value: function _onContentChanged(_ref12) {
      var id = _ref12.id,
          type = _ref12.type;

      debug('Content changed for: ' + type + '/' + id);
      // Notify global subscriber that something changed recently
      this._allContentsChangeSubscriber.next();
    }
  }, {
    key: '_onChildrenChanged',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(_ref14, _ref15) {
        var _this5 = this;

        var id = _ref14.id,
            type = _ref14.type;
        var oldValue = _ref15.oldValue;
        var oldChildren, newChildren, removedChildren;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                debug('Children changed for: ' + type + '/' + id);

                oldChildren = oldValue.children;
                _context7.next = 4;
                return this.metaOf({ id: id, type: type });

              case 4:
                newChildren = _context7.sent.children;
                removedChildren = oldChildren.filter(function (_ref16) {
                  var ocId = _ref16.id,
                      ocType = _ref16.type;
                  return newChildren.filter(function (_ref17) {
                    var ncId = _ref17.id,
                        ncType = _ref17.type;
                    return ocId === ncId && ocType === ncType;
                  }).length === 0;
                });


                removedChildren.map(function (_ref18) {
                  var rId = _ref18.id,
                      rType = _ref18.type;
                  return _this5._deleteContent({ id: rId, type: rType });
                });

                // Notify global subscriber that something changed recently
                this._allContentsChangeSubscriber.next();

              case 8:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _onChildrenChanged(_x3, _x4) {
        return _ref13.apply(this, arguments);
      }

      return _onChildrenChanged;
    }()
  }, {
    key: '_deleteContent',
    value: function _deleteContent(_ref19) {
      var _this6 = this;

      var id = _ref19.id,
          type = _ref19.type;

      this._cache.remove({ id: type + '/content/' + id });
      var meta = this._cache.remove({ id: type + '/meta/' + id });

      if (meta && meta.children) {
        meta.children.map(function (_ref20) {
          var rId = _ref20.id,
              rType = _ref20.type;
          return _this6._deleteContent({ id: rId, type: rType });
        });
      }
    }
  }, {
    key: '_getWatcherFunction',
    value: function _getWatcherFunction(_ref21) {
      var _this7 = this;

      var candidateFn = _ref21.candidateFn,
          id = _ref21.id,
          type = _ref21.type;

      return function (_ref22) {
        var notifyFn = _ref22.notifyFn;

        var fn = candidateFn || ContentManager.defaultWatcher;
        if (!_this7._checkForChanges) {
          fn = ContentManager.defaultWatcher;
        }
        return fn({ id: id, notifyFn: notifyFn, type: type });
      };
    }
  }]);
  return ContentManager;
}();

ContentManager.defaultWatcher = function () {
  return null;
};
ContentManager.defaultChildrenCalculator = function () {
  return [];
};