'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProjectRunner = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dynamic = require('./renderer/dynamic');

var _project = require('./project');

var _static = require('./renderer/static');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ProjectRunner = exports.ProjectRunner = function () {
  function ProjectRunner(_ref) {
    var project = _ref.project,
        listenToChanges = _ref.listenToChanges,
        useCache = _ref.useCache;
    (0, _classCallCheck3.default)(this, ProjectRunner);

    this._project = new _project.Project({ listenToChanges: listenToChanges, project: project, useCache: useCache });
    this._useCache = useCache;
  }

  (0, _createClass3.default)(ProjectRunner, [{
    key: 'init',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._project.initCache();

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _ref2.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'generateStatic',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return new _static.StaticRenderer({ project: this._project }).render();

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function generateStatic() {
        return _ref3.apply(this, arguments);
      }

      return generateStatic;
    }()
  }, {
    key: 'generateDynamic',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', new _dynamic.DynamicRenderer({ project: this._project }).render());

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function generateDynamic() {
        return _ref4.apply(this, arguments);
      }

      return generateDynamic;
    }()
  }, {
    key: 'persistCache',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (this._useCache) {
                  _context4.next = 2;
                  break;
                }

                return _context4.abrupt('return');

              case 2:
                return _context4.abrupt('return', this._project.persistCache());

              case 3:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function persistCache() {
        return _ref5.apply(this, arguments);
      }

      return persistCache;
    }()
  }]);
  return ProjectRunner;
}();