'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DynamicRenderer = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _browserSync = require('browser-sync');

var _browserSync2 = _interopRequireDefault(_browserSync);

var _http = require('../utils/http');

var _http2 = require('http');

var _http3 = _interopRequireDefault(_http2);

var _misc = require('../utils/misc');

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-console */
var DynamicRenderer = exports.DynamicRenderer = function () {
  function DynamicRenderer(_ref) {
    var project = _ref.project;
    (0, _classCallCheck3.default)(this, DynamicRenderer);

    this._project = project;
  }

  (0, _createClass3.default)(DynamicRenderer, [{
    key: 'handleRequest',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(request, response) {
        var url, urlInfo, handledUrlList, generatedPage, body, headers;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                url = _url2.default.parse(request.url);

                if (!(url.query === 'urlList')) {
                  _context.next = 8;
                  break;
                }

                _context.next = 4;
                return this._project.handledUrls();

              case 4:
                urlInfo = _context.sent;
                handledUrlList = urlInfo.urls.map(function (_ref3) {
                  var u = _ref3.url;
                  return u;
                });

                DynamicRenderer.renderUrlList({ handledUrlList: handledUrlList, response: response });
                return _context.abrupt('return');

              case 8:
                _context.next = 10;
                return this._project.handle({ url: url.pathname }).catch(_misc.translateError);

              case 10:
                generatedPage = _context.sent;

                if (!(generatedPage instanceof Error)) {
                  _context.next = 14;
                  break;
                }

                if (generatedPage.message === '404') {
                  DynamicRenderer.render404({ response: response });
                } else {
                  DynamicRenderer.render500({ error: generatedPage, response: response });
                }
                return _context.abrupt('return');

              case 14:
                body = generatedPage.body;
                headers = (0, _http.headersFor)({ url: url.pathname });


                response.writeHead(200, headers);
                response.end(body);

              case 18:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleRequest(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return handleRequest;
    }()
  }, {
    key: 'render',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var _this = this;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', new _promise2.default(function (resolve, reject) {
                  _http3.default.createServer(_this.handleRequest.bind(_this)).listen(4000, function (err) {
                    if (err) {
                      reject(err);
                      return;
                    }
                    var bs = _browserSync2.default.create();

                    bs.init({
                      open: false,
                      proxy: 'localhost:4000'
                    });
                    _this._project.watcher$().subscribe(function () {
                      bs.reload();
                    });
                    resolve();
                  });
                }));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function render() {
        return _ref4.apply(this, arguments);
      }

      return render;
    }()
  }]);
  return DynamicRenderer;
}();

DynamicRenderer.render404 = function (_ref5) {
  var response = _ref5.response;

  response.writeHead(404);
  response.end('404 - Nein!');
};
DynamicRenderer.render500 = function (_ref6) {
  var error = _ref6.error,
      response = _ref6.response;

  console.error(error);
  response.writeHead(500);
  response.end('<head></head><body>500 - Check console</body>');
};
DynamicRenderer.renderUrlList = function (_ref7) {
  var handledUrlList = _ref7.handledUrlList,
      response = _ref7.response;

  var body = [handledUrlList.length + ' urls'].concat((0, _toConsumableArray3.default)(handledUrlList)).join('\n');

  response.writeHead(200, { 'Content-Type': 'text/plain' });
  response.write(body);
  response.end();
};