'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaticRenderer = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _gauge = require('gauge');

var _gauge2 = _interopRequireDefault(_gauge);

var _routeManager = require('../routeManager');

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StaticRenderer = exports.StaticRenderer = function () {
  function StaticRenderer(_ref) {
    var project = _ref.project;
    (0, _classCallCheck3.default)(this, StaticRenderer);

    this._project = project;
    this._gauge = new _gauge2.default();
  }

  (0, _createClass3.default)(StaticRenderer, [{
    key: 'render',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var _this = this;

        var _ref3, duplicates, urls, totalCount, idx;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._gauge.show('Getting url list...', 0);
                _context.next = 3;
                return this._project.handledUrls();

              case 3:
                _ref3 = _context.sent;
                duplicates = _ref3.duplicates;
                urls = _ref3.urls;

                if (!((0, _keys2.default)(duplicates).length > 0)) {
                  _context.next = 8;
                  break;
                }

                throw new Error(_routeManager.RouteManager.generateDuplicateUrlErrorText(duplicates));

              case 8:
                totalCount = urls.length;
                idx = 0;
                _context.next = 12;
                return this._project.handleAll({
                  urlProcessFn: function urlProcessFn(_ref4) {
                    var url = _ref4.url,
                        body = _ref4.body,
                        handlerId = _ref4.handlerId;

                    idx++;
                    _this._gauge.show(handlerId, idx / totalCount);
                    _this._gauge.pulse(url);

                    var pathToWrite = _path2.default.join(_this._project.outPath(), url);

                    if (url.endsWith('/')) {
                      pathToWrite = _path2.default.join(pathToWrite, 'index.html');
                    }

                    return _fsExtra2.default.outputFile(pathToWrite, body);
                  }
                });

              case 12:

                this._gauge.hide();

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function render() {
        return _ref2.apply(this, arguments);
      }

      return render;
    }()
  }]);
  return StaticRenderer;
}();