'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RouteManager = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RouteManager = exports.RouteManager = function () {
  function RouteManager(_ref) {
    var project = _ref.project;
    (0, _classCallCheck3.default)(this, RouteManager);

    this._project = project;
  }

  (0, _createClass3.default)(RouteManager, [{
    key: 'handle',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref3) {
        var url = _ref3.url;

        var _ref4, duplicates, urls, urlData, handler, data, _ref5, body;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.handledUrls();

              case 2:
                _ref4 = _context.sent;
                duplicates = _ref4.duplicates;
                urls = _ref4.urls;

                if (!((0, _keys2.default)(duplicates).length > 0)) {
                  _context.next = 7;
                  break;
                }

                throw new Error(RouteManager.generateDuplicateUrlErrorText(duplicates));

              case 7:
                urlData = urls.find(function (uData) {
                  return uData.url === url;
                });

                if (urlData) {
                  _context.next = 10;
                  break;
                }

                throw new Error('404');

              case 10:
                handler = urlData.handler, data = urlData.data;
                _context.next = 13;
                return this._project.valueOf({ _data: data, id: url, type: handler });

              case 13:
                _ref5 = _context.sent;
                body = _ref5.body;
                return _context.abrupt('return', { body: body });

              case 16:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handle(_x) {
        return _ref2.apply(this, arguments);
      }

      return handle;
    }()
  }, {
    key: 'handledUrls',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var handledUrlsPerHandler, urlMap, duplicateUrls;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._handledUrlsPerHandler();

              case 2:
                handledUrlsPerHandler = _context2.sent;
                urlMap = {};
                duplicateUrls = {};


                (0, _keys2.default)(handledUrlsPerHandler).forEach(function (handlerId) {
                  var handledUrls = handledUrlsPerHandler[handlerId];
                  handledUrls.forEach(function (_ref7) {
                    var url = _ref7.url,
                        data = _ref7.data;

                    if (typeof urlMap[url] === 'undefined') {
                      urlMap[url] = {
                        data: data,
                        handler: [handlerId]
                      };
                    } else {
                      urlMap[url].handler.push(handlerId);
                      duplicateUrls[url] = { handler: [].concat((0, _toConsumableArray3.default)(urlMap[url].handler)) };
                    }
                  });
                });

                return _context2.abrupt('return', {
                  duplicates: duplicateUrls,
                  urls: (0, _keys2.default)(urlMap).map(function (url) {
                    var data = urlMap[url].data;
                    var handler = urlMap[url].handler[0];
                    return { data: data, handler: handler, url: url };
                  })
                });

              case 7:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function handledUrls() {
        return _ref6.apply(this, arguments);
      }

      return handledUrls;
    }()
  }, {
    key: 'handleAll',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(_ref9) {
        var urlProcessFn = _ref9.urlProcessFn;

        var urlListPerHandler, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, handlerId, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _ref11, url, data, _ref12, body;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._handledUrlsPerHandler();

              case 2:
                urlListPerHandler = _context3.sent;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context3.prev = 6;
                _iterator = (0, _getIterator3.default)((0, _keys2.default)(urlListPerHandler));

              case 8:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context3.next = 44;
                  break;
                }

                handlerId = _step.value;
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context3.prev = 13;
                _iterator2 = (0, _getIterator3.default)(urlListPerHandler[handlerId]);

              case 15:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context3.next = 27;
                  break;
                }

                _ref11 = _step2.value;
                url = _ref11.url, data = _ref11.data;
                _context3.next = 20;
                return this._project.valueOf({ // eslint-disable-line no-await-in-loop
                  _data: data,
                  id: url,
                  type: handlerId
                });

              case 20:
                _ref12 = _context3.sent;
                body = _ref12.body;
                _context3.next = 24;
                return urlProcessFn({ body: body, handlerId: handlerId, url: url });

              case 24:
                _iteratorNormalCompletion2 = true;
                _context3.next = 15;
                break;

              case 27:
                _context3.next = 33;
                break;

              case 29:
                _context3.prev = 29;
                _context3.t0 = _context3['catch'](13);
                _didIteratorError2 = true;
                _iteratorError2 = _context3.t0;

              case 33:
                _context3.prev = 33;
                _context3.prev = 34;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 36:
                _context3.prev = 36;

                if (!_didIteratorError2) {
                  _context3.next = 39;
                  break;
                }

                throw _iteratorError2;

              case 39:
                return _context3.finish(36);

              case 40:
                return _context3.finish(33);

              case 41:
                _iteratorNormalCompletion = true;
                _context3.next = 8;
                break;

              case 44:
                _context3.next = 50;
                break;

              case 46:
                _context3.prev = 46;
                _context3.t1 = _context3['catch'](6);
                _didIteratorError = true;
                _iteratorError = _context3.t1;

              case 50:
                _context3.prev = 50;
                _context3.prev = 51;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 53:
                _context3.prev = 53;

                if (!_didIteratorError) {
                  _context3.next = 56;
                  break;
                }

                throw _iteratorError;

              case 56:
                return _context3.finish(53);

              case 57:
                return _context3.finish(50);

              case 58:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[6, 46, 50, 58], [13, 29, 33, 41], [34,, 36, 40], [51,, 53, 57]]);
      }));

      function handleAll(_x2) {
        return _ref8.apply(this, arguments);
      }

      return handleAll;
    }()

    /* Private operations */

  }, {
    key: '_handledUrlListFor',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref14) {
        var handlerId = _ref14.handlerId;

        var _ref15, children;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._project.metaOf({ id: null, type: handlerId });

              case 2:
                _ref15 = _context4.sent;
                children = _ref15.children;
                return _context4.abrupt('return', children.map(function (_ref16) {
                  var _data = _ref16._data,
                      id = _ref16.id;
                  return { data: _data, url: id };
                }));

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _handledUrlListFor(_x3) {
        return _ref13.apply(this, arguments);
      }

      return _handledUrlListFor;
    }()
  }, {
    key: '_handledUrlsPerHandler',
    value: function () {
      var _ref17 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var _this = this;

        var contentTypes, urlListPerHandler;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                contentTypes = (0, _keys2.default)(this._project._project.routeHandlers); // eslint-disable-line no-underscore-dangle

                _context5.next = 3;
                return _promise2.default.all(contentTypes.map(function (handlerId) {
                  return _this._handledUrlListFor({ handlerId: handlerId });
                }));

              case 3:
                urlListPerHandler = _context5.sent;
                return _context5.abrupt('return', contentTypes.reduce(function (acc, handlerId, index) {
                  return (0, _assign2.default)((0, _defineProperty3.default)({}, handlerId, urlListPerHandler[index]), acc);
                }, {}));

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _handledUrlsPerHandler() {
        return _ref17.apply(this, arguments);
      }

      return _handledUrlsPerHandler;
    }()
  }]);
  return RouteManager;
}();

RouteManager.generateDuplicateUrlErrorText = function (duplicates) {
  var string = "Some url's are handled by more than one handler. Please fix duplicated handling and try again:\n\n";
  (0, _keys2.default)(duplicates).forEach(function (url) {
    var handlers = duplicates[url].handler;
    string += url + ' is handled by ' + handlers.join(', ') + '\n';
  });
  return string;
};