'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toObservable = exports.translateError = exports.deepMap = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

var _lodash = require('lodash.isplainobject');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// https://gist.github.com/spion/8c9d8556697ed61108177164e90fb50d
var translateError = function translateError(e) {
  return e;
};

var mapObject = function mapObject(obj, fn) {
  return (0, _keys2.default)(obj).reduce(function (acc, key) {
    acc[key] = fn(obj[key]);
    return acc;
  }, {});
};

var deepMap = function deepMap(obj, fn) {
  if (Array.isArray(obj)) {
    return obj.map(function (val) {
      return deepMap(val, fn);
    });
  }

  if ((0, _lodash2.default)(obj)) {
    return mapObject(obj, function (val) {
      return deepMap(val, fn);
    });
  }

  return fn(obj);
};

var toObservable = function toObservable(_ref) {
  var fn = _ref.fn;

  if (!fn) {
    return _Rx2.default.Observable.empty();
  }

  return _Rx2.default.Observable.create(function (subscriber) {
    var notifyFn = function notifyFn() {
      subscriber.next();
    };
    var retVal = fn({ notifyFn: notifyFn });
    var unsubscribeFn = retVal && retVal.unsubscribe ? retVal.unsubscribe : function () {
      return {};
    };

    return function () {
      return unsubscribeFn();
    };
  });
};

exports.deepMap = deepMap;
exports.translateError = translateError;
exports.toObservable = toObservable;